from datatypes.DriveCommand import DriveCommand
from datetime import datetime
from decimal import Decimal

class DriveCommandImpl(DriveCommand):
    """Implementation of the application data type DriveCommand. 
       Generated by: EASy-Producer."""
 
    #Mapped into properties without leading _ below resembling getter/setter
    
    _iFriction_set: int = 0
    _iTension_set: int = 0
    _rPosition: float = 0.0
    _rVelocity: float = 0.0
    _bExecute: bool = None
    
    def getIFriction_set(self) -> int:
        """Returns the value of {@code iFriction_set}. Desired friction incident in percentage, 0 is normal
        
           Returns:
             - the value of iFriction_set"""
        return self._iFriction_set
    
    def getITension_set(self) -> int:
        """Returns the value of {@code iTension_set}. Desired tension incident in percentage, 100 is normal
        
           Returns:
             - the value of iTension_set"""
        return self._iTension_set
    
    def getRPosition(self) -> float:
        """Returns the value of {@code rPosition}. Target position in mm
        
           Returns:
             - the value of rPosition"""
        return self._rPosition
    
    def getRVelocity(self) -> float:
        """Returns the value of {@code rVelocity}. Movement velocity position in mm/min, always 100
        
           Returns:
             - the value of rVelocity"""
        return self._rVelocity
    
    def getBExecute(self) -> bool:
        """Returns the value of {@code bExecute}.
        
           Returns:
             - the value of bExecute"""
        return self._bExecute
    
    
    def setIFriction_set(self, v):
        """Changes the value of {@code iFriction_set}. Desired friction incident in percentage, 0 is normal
        
           Parameters:
             - v -- the new value of iFriction_set, may be of type int or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._iFriction_set = v.item()
        else:
            self._iFriction_set = v
    
    def setITension_set(self, v):
        """Changes the value of {@code iTension_set}. Desired tension incident in percentage, 100 is normal
        
           Parameters:
             - v -- the new value of iTension_set, may be of type int or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._iTension_set = v.item()
        else:
            self._iTension_set = v
    
    def setRPosition(self, v):
        """Changes the value of {@code rPosition}. Target position in mm
        
           Parameters:
             - v -- the new value of rPosition, may be of type float or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._rPosition = v.item()
        else:
            self._rPosition = v
    
    def setRVelocity(self, v):
        """Changes the value of {@code rVelocity}. Movement velocity position in mm/min, always 100
        
           Parameters:
             - v -- the new value of rVelocity, may be of type float or the corresponding numpy type"""
        if ("numpy" in str(type(v))):
            self._rVelocity = v.item()
        else:
            self._rVelocity = v
    
    def setBExecute(self, v: bool):
        """Changes the value of {@code bExecute}.
        
           Parameters:
             - v -- the new value of bExecute"""
        if ("numpy" in str(type(v))):
            self._bExecute = v.item()
        else:
            self._bExecute = v
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    iFriction_set = property(getIFriction_set, setIFriction_set)
    iTension_set = property(getITension_set, setITension_set)
    rPosition = property(getRPosition, setRPosition)
    rVelocity = property(getRVelocity, setRVelocity)
    bExecute = property(getBExecute, setBExecute)
    
