
from datetime import datetime
from decimal import Decimal

class PlcEnergyMeasurement:
    """Interface of the application data type PlcEnergyMeasurement. 
       Generated by: EASy-Producer."""
 
    
    def getValue(self) -> str:
        """Returns the value of {@code value}.
        
           Returns:
             - the value of value"""
        raise NotImplementedError
    
    def getTimestamp(self) -> datetime:
        """Returns the value of {@code timestamp}.
        
           Returns:
             - the value of timestamp"""
        raise NotImplementedError
    
    def getChannel(self) -> str:
        """Returns the value of {@code channel}.
        
           Returns:
             - the value of channel"""
        raise NotImplementedError
    
    
    def setValue(self, v: str):
        """Changes the value of {@code value}.
        
           Parameters:
             - v -- the new value of value"""
        raise NotImplementedError
    
    def setTimestamp(self, v: datetime):
        """Changes the value of {@code timestamp}.
        
           Parameters:
             - v -- the new value of timestamp"""
        raise NotImplementedError
    
    def setChannel(self, v: str):
        """Changes the value of {@code channel}.
        
           Parameters:
             - v -- the new value of channel"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    value = property(getValue, setValue)
    timestamp = property(getTimestamp, setTimestamp)
    channel = property(getChannel, setChannel)
    
