
from datetime import datetime
from decimal import Decimal

class PlcEnergyMeasurementChannel:
    """Interface of the application data type PlcEnergyMeasurementChannel. 
       Generated by: EASy-Producer."""
 
    
    def getValues(self) -> list:
        """Returns the value of {@code values}.
        
           Returns:
             - the value of values"""
        raise NotImplementedError
    
    def getTimestamp(self) -> datetime:
        """Returns the value of {@code timestamp}.
        
           Returns:
             - the value of timestamp"""
        raise NotImplementedError
    
    def getChannel(self) -> str:
        """Returns the value of {@code channel}.
        
           Returns:
             - the value of channel"""
        raise NotImplementedError
    
    def getSamplerate(self) -> float:
        """Returns the value of {@code samplerate}. sample rate in (fraction of) seconds, time period between two measurements
        
           Returns:
             - the value of samplerate"""
        raise NotImplementedError
    
    
    def setValues(self, v: list):
        """Changes the value of {@code values}.
        
           Parameters:
             - v -- the new value of values"""
        raise NotImplementedError
    
    def setTimestamp(self, v: datetime):
        """Changes the value of {@code timestamp}.
        
           Parameters:
             - v -- the new value of timestamp"""
        raise NotImplementedError
    
    def setChannel(self, v: str):
        """Changes the value of {@code channel}.
        
           Parameters:
             - v -- the new value of channel"""
        raise NotImplementedError
    
    def setSamplerate(self, v):
        """Changes the value of {@code samplerate}. sample rate in (fraction of) seconds, time period between two measurements
        
           Parameters:
             - v -- the new value of samplerate, may be of type float or the corresponding numpy type"""
        raise NotImplementedError
    
    
    #Indeed, there are 2.4 decorators for this, but for now we want to have all here: pythonic field access
    #backed by getter/setter and the ability to replace data classes by e.g. projecting or data enhancing
    #functionality (original idea of the "interfaces" with similar naming as in Java. It may be that the 
    #interfaces become superfluous due to the properties, but let's leave them in for now.
    values = property(getValues, setValues)
    timestamp = property(getTimestamp, setTimestamp)
    channel = property(getChannel, setChannel)
    samplerate = property(getSamplerate, setSamplerate)
    
