from json import JSONEncoder
import json
from datetime import datetime
from TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.DriveAiResult import DriveAiResult
from datatypes.DriveAiResultImpl import DriveAiResultImpl







from datatypes.PlcEnergyMeasurementChannel import PlcEnergyMeasurementChannel

from serializers.PlcEnergyMeasurementChannelSerializer import PlcEnergyMeasurementChannelSerializer
from datatypes.AggregatedPlcEnergyMeasurement import AggregatedPlcEnergyMeasurement

from serializers.AggregatedPlcEnergyMeasurementSerializer import AggregatedPlcEnergyMeasurementSerializer










from datatypes.LenzeDriveMeasurementChannel import LenzeDriveMeasurementChannel

from serializers.LenzeDriveMeasurementChannelSerializer import LenzeDriveMeasurementChannelSerializer
from datatypes.LenzeDriveMeasurementProcess import LenzeDriveMeasurementProcess

from serializers.LenzeDriveMeasurementProcessSerializer import LenzeDriveMeasurementProcessSerializer
from datatypes.LenzeDriveMeasurement import LenzeDriveMeasurement

from serializers.LenzeDriveMeasurementSerializer import LenzeDriveMeasurementSerializer


class DriveAiResultEncoder(JSONEncoder):
    """JSON encoder class for DriveAiResult.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        tmp = dict()
        for key in o.__dict__:
            k = key[1:] # by generation convention
            tmp[k] = o.__dict__[key]
        if "_energy" in tmp:
            tmp["_energy"] = AggregatedPlcEnergyMeasurementSerializer.writeToAggregatedPlcEnergyMeasurement(tmp["_energy"])
        if "_drive" in tmp:
            tmp["_drive"] = LenzeDriveMeasurementSerializer.writeToLenzeDriveMeasurement(tmp["_drive"])
        
        return tmp
    

class DriveAiResultSerializer(TypeTranslatorToString):
    """JSON transport serializer for DriveAiResult.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["DriveAiResult"] = self
        Registry.types[DriveAiResult] = "DriveAiResult"
        Registry.serializers["DriveAiResultImpl"] = self # there is a serializer for the Impl
        Registry.types[DriveAiResultImpl] = "DriveAiResult" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> DriveAiResult:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = DriveAiResultImpl()
        jTmp = json.loads(data)
        tmp = dict()
        for key in jTmp:
            k = "_" + str(key) # by generation convention
            tmp[k] = jTmp[key]
        if "_error" in tmp:
            tmplist = tmp["_error"]
            tmp["_error"] = []
            for i in tmplist: 
                tmp["_error"].append(i)
                
        if "_errorConfidence" in tmp:
            tmplist = tmp["_errorConfidence"]
            tmp["_errorConfidence"] = []
            for i in tmplist: 
                tmp["_errorConfidence"].append(i)
                
        
        if "_energy" in tmp:
            tmp["_energy"] = AggregatedPlcEnergyMeasurementSerializer.readFromAggregatedPlcEnergyMeasurement(tmp["_energy"])
        if "_drive" in tmp:
            tmp["_drive"] = LenzeDriveMeasurementSerializer.readFromLenzeDriveMeasurement(tmp["_drive"])
        
        result.__dict__ = tmp
        return result

    def writeTo(self, source: DriveAiResult) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return DriveAiResultEncoder().encode(source).encode("UTF-8").decode()
        
    def readFromDriveAiResult(d: dict) -> DriveAiResult:
        """Turns a dict into an object of type DriveAiResult for deep deserialization.
        
        Parameters:
          - d -- dict
        Returns:
          DriveAiResult
            the object, may be None
        """
        if d is None:
            return None
        else:
            tmp = dict()
            result = DriveAiResultImpl()
            for key in d:
                k = "_" + str(key) # by generation convention
                tmp[k] = d[key]
            if "_error" in tmp:
                tmplist = tmp["_error"]
                tmp["_error"] = []
                for i in tmplist: 
                    tmp["_error"].append(i)
                    
            if "_errorConfidence" in tmp:
                tmplist = tmp["_errorConfidence"]
                tmp["_errorConfidence"] = []
                for i in tmplist: 
                    tmp["_errorConfidence"].append(i)
                    
            
            if "_energy" in tmp:
                tmp["_energy"] = AggregatedPlcEnergyMeasurementSerializer.readFromAggregatedPlcEnergyMeasurement(tmp["_energy"])
            if "_drive" in tmp:
                tmp["_drive"] = LenzeDriveMeasurementSerializer.readFromLenzeDriveMeasurement(tmp["_drive"])
            
            result.__dict__ = tmp
            return result
    
    def writeToDriveAiResult(o: DriveAiResult) -> dict:
        """Turns an object of type DriveAiResult into a dict for serialization.
        
        Parameters:
          - o -- the object, may be None
        Returns:
          dict
            the dict, may be None
        """
        if o is None:
            return None
        else:
            result = dict()
            for key in o.__dict__:
                k = key[1:] # by generation convention
                result[k] = o.__dict__[key]

DriveAiResultSerializer()
