from json import JSONEncoder
import json
from datetime import datetime
from TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.PlcOutput import PlcOutput
from datatypes.PlcOutputImpl import PlcOutputImpl









class PlcOutputEncoder(JSONEncoder):
    """JSON encoder class for PlcOutput.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        tmp = dict()
        for key in o.__dict__:
            k = key[1:] # by generation convention
            tmp[k] = o.__dict__[key]
        
        return tmp
    

class PlcOutputSerializer(TypeTranslatorToString):
    """JSON transport serializer for PlcOutput.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["PlcOutput"] = self
        Registry.types[PlcOutput] = "PlcOutput"
        Registry.serializers["PlcOutputImpl"] = self # there is a serializer for the Impl
        Registry.types[PlcOutputImpl] = "PlcOutput" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> PlcOutput:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = PlcOutputImpl()
        jTmp = json.loads(data)
        tmp = dict()
        for key in jTmp:
            k = "_" + str(key) # by generation convention
            tmp[k] = jTmp[key]
        
        result.__dict__ = tmp
        return result

    def writeTo(self, source: PlcOutput) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return PlcOutputEncoder().encode(source).encode("UTF-8").decode()
        
    def readFromPlcOutput(d: dict) -> PlcOutput:
        """Turns a dict into an object of type PlcOutput for deep deserialization.
        
        Parameters:
          - d -- dict
        Returns:
          PlcOutput
            the object, may be None
        """
        if d is None:
            return None
        else:
            tmp = dict()
            result = PlcOutputImpl()
            for key in d:
                k = "_" + str(key) # by generation convention
                tmp[k] = d[key]
            
            result.__dict__ = tmp
            return result
    
    def writeToPlcOutput(o: PlcOutput) -> dict:
        """Turns an object of type PlcOutput into a dict for serialization.
        
        Parameters:
          - o -- the object, may be None
        Returns:
          dict
            the dict, may be None
        """
        if o is None:
            return None
        else:
            result = dict()
            for key in o.__dict__:
                k = key[1:] # by generation convention
                result[k] = o.__dict__[key]

PlcOutputSerializer()
